/*-- ================================================================== --
-- SISTEMA         : GESTAO DE VENDAS                                   --
-- DATA DA CRIAO : 06/12/2006                                         --
-- CRIAO         : LUCIANA CORREA                                     --
-- OBJETIVOS       : CANCELA VENDA PARA T&TEL                           --
-- ==================================================================== --
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CANCELA_VENDA_TTEL' AND
	        TYPE = 'P'                  AND
	        U.UID = O.UID               AND
	        U.NAME = USER)

   DROP PROCEDURE CANCELA_VENDA_TTEL
   GO

CREATE PROCEDURE CANCELA_VENDA_TTEL
  @P_CDFILIAL     VARCHAR(4),
  @P_CDCAIXA      VARCHAR(3),
  @P_NRSEQVENDA   VARCHAR(10),
  @P_RETORNO      VARCHAR(50) OUTPUT

AS
BEGIN
   DECLARE @V_NRSEQTTEL    VARCHAR(50);
   DECLARE @V_ERRO         VARCHAR(10);
   DECLARE @V_NRSEQVENDA   VARCHAR(10);
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_CDCONSUMIDOR VARCHAR(21);
   DECLARE @V_CDFAMILIA    VARCHAR(03);

   SELECT @V_NRSEQVENDA   = NRSEQVENDA,
          @V_CDCLIENTE    = CDCLIENTE,
          @V_CDCONSUMIDOR = CDCONSUMIDOR
   FROM   VENDA
   WHERE  CDFILIAL   = @P_CDFILIAL
     AND  CDCAIXA    = @P_CDCAIXA
     AND  NRSEQVENDA = @P_NRSEQVENDA;
   IF @V_NRSEQVENDA IS NULL BEGIN
      SET @V_NRSEQTTEL = 'VENDA NAO ENCONTRADA';
      SET @V_ERRO = 'ERRO';
   END;

   BEGIN TRANSACTION;
   
   UPDATE VENDA
   SET IDSITUVENDA = 'C',
       TXOBSVENDA  = 'CANCELAMENTO VENDA PROCEDURE T&TEL'
   WHERE CDFILIAL   = @P_CDFILIAL
     AND CDCAIXA    = @P_CDCAIXA
     AND NRSEQVENDA = @P_NRSEQVENDA;
   IF @@ERROR <> 0 BEGIN
      SET @V_NRSEQTTEL = 'ERRO UPDATE TABELA VENDA'
      SET @V_ERRO = 'ERRO';
   END;

   UPDATE MOVCAIXA
   SET    IDTIPOMOVIVE = 'C'
   WHERE CDFILIAL   = @P_CDFILIAL
     AND CDCAIXA    = @P_CDCAIXA
     AND NRSEQVENDA = @P_NRSEQVENDA;
   IF @@ERROR <> 0 BEGIN
      SET @V_NRSEQTTEL = 'ERRO UPDATE TABELA MOVCAIXA';
      SET @V_ERRO = 'ERRO';
   END;

   DECLARE C_FAMILIA CURSOR FOR
   SELECT DISTINCT CDFAMILISALD
   FROM   FAMSALDOFILI
   WHERE CDFILIAL     = @P_CDFILIAL;

   DELETE FROM EXTRATOCONS
   WHERE CDCLIENTE    = @V_CDCLIENTE
     AND CDCONSUMIDOR = @V_CDCONSUMIDOR
     AND CDFILIAL     = @P_CDFILIAL
     AND CDCAIXA      = @P_CDCAIXA
     AND NRSEQVENDA   = @V_NRSEQVENDA;

   OPEN C_FAMILIA;
   FETCH NEXT FROM C_FAMILIA INTO @V_CDFAMILIA
   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXECUTE ATUALIZA_SALDO_CONS_FKB @P_CDFILIAL,@V_CDCLIENTE,@V_CDCONSUMIDOR,@V_CDFAMILIA;
      FETCH NEXT FROM C_FAMILIA INTO @V_CDFAMILIA
   END;
   CLOSE C_FAMILIA;
   DEALLOCATE C_FAMILIA;

   IF @V_ERRO = 'ERRO' BEGIN
      SET @P_RETORNO = @V_NRSEQTTEL;
      ROLLBACK;
   END ELSE BEGIN
      SET @P_RETORNO = 'VENDA CANCELADA';
      COMMIT;
   END;
END;
GO

BEGIN
DECLARE @RETORNO VARCHAR(50);
EXECUTE CANCELA_VENDA_TTEL '9408','001','0',@RETORNO OUTPUT
PRINT @RETORNO
END

